!-----------------------------------------------------------------------------
! 110215_sokendai/src/Leibniz
!                                       Akira Kageyama
!                                       kage@cs.kobe-u.ac.jp
!---------------------------------------------------------------------
!
! leibniz.f90
!
!      Calculate pi by the Leibniz formula.
!                       by: Akira Kageyama
!                       on: 2011.02.15
!                      for: Sokendai Winter School, NIFS, Japan
!---------------------------------------------------------------------
!

program leibniz
  implicit none
  integer, parameter :: SP = kind(1.0)
  integer, parameter :: DP = selected_real_kind(2*precision(1.0_SP))
  real(DP) :: sign = -1.0_DP
  real(DP) :: sum  = 0.0_DP
  integer  :: i

  do i =  2*(10**6)+1 , 1 , -2   ! odd intergers
     sign = sign * (-1.0_DP)
     sum = sum + sign/i
  end do

  print *, ' 4*sum = ', 4*sum

end program leibniz
